【力扣每日一题】lc1969. 数组元素的最小非零乘积(思维+构造)

lc1969. 数组元素的最小非零乘积

题目描述

给你一个正整数 p 。你有一个下标从 1 开始的数组 nums ,这个数组包含范围 1, 2p - 1 内所有整数的二进制形式(两端都 包含)。你可以进行以下操作 任意 次:

从 nums 中选择两个元素 x 和 y 。

选择 x 中的一位与 y 对应位置的位交换。对应位置指的是两个整数 相同位置 的二进制位。

比方说,如果 x = 1101 且 y = 0011 ,交换右边数起第 2 位后,我们得到 x = 1111 和 y = 0001 。

请你算出进行以上操作 任意次 以后,nums 能得到的 最小非零 乘积。将乘积对 109 + 7 取余 后返回。

注意:答案应为取余 之前 的最小值。

1 <= p <= 60

思路

我们注意到,每一次操作,并不会改变元素的和,而在元素和不变的情况下,要想使得乘积最小,应该尽可能最大化元素的差值。

由于最大的元素为 2^p−1,无论与哪个元素交换,都不会使得差值变大,因此我们不需要考虑与最大元素交换的情况。

对于其它的[1,..2^p−2]的元素,我们依次将首尾元素两两配对,即 x 与 [1,..2^p−1-x] 进行配置,那么经过若干次操作过后,每一对元素都变成了 (1,2^p−2),那么最终的乘积为 (2^p−1)×(2^p−2)^(2^(p-1)-1)

代码

复制代码
class Solution:
    def minNonZeroProduct(self, p: int) -> int:
        mod = 10**9+7
        def qpow(a,b):
            res = 1
            while b>0:
                if (b&1)==1:
                    res = res * a%mod
                a = a * a%mod
                b>>=1
            return res
        kk = 2**p-1
        bb = 2**(p-1)-1
        return kk%mod * qpow((kk-1),bb)%mod # 也可以用python自带的pow(a,b,mod)
相关推荐
严肃小白兔10 分钟前
MATLAB 数值计算中的精度与误差问题:浮点运算、误差传播与数值稳定性
人工智能·算法·matlab
青少儿编程课堂1 小时前
蓝桥杯青少组图形化省考报名倒计时·全国青少年信息素养大赛·电子学会图形化考级:校园黑白棋人机对战解析
c++·python·算法·bfs·信息学竞赛
jktantan2 小时前
注解式脱敏:用 Jackson 的 ContextualSerializer 做字段级策略(一)
spring boot·后端·算法·spring cloud·系统架构
Dream it possible!15 小时前
LeetCode 面试经典 150_多维动态规划_交错字符串(97_C++_中等)
算法·leetcode·面试·动态规划
心抵鹊15 小时前
算法之双指针系列(一)
算法·leetcode
十二15 小时前
【洛谷题解】P1083 [NOIP 2012 提高组] 借教室(二分答案 + 差分)
数据结构·c++·算法·蓝桥杯
小此方16 小时前
[算法实战论:动态规划]回文串问题的dp解法,回文串问题的母题,以及以此为基础的派生题
算法·动态规划
Pniubi17 小时前
力扣560.和为k的子数组
算法·leetcode·职场和发展
D e re k ZH17 小时前
C++ 从零入门(一):基础语法与程序结构
数据结构·c++·算法
Pniubi18 小时前
力扣438.找到字符串中所有字母异位词
算法·leetcode·职场和发展